/***************************************************************************
 *   Copyright (C) 2010 by Naomasa Matsubayashi   *
 *   fadis@quaternion.sakura.ne.jp   *
 *                                                                         *
 *   All rights reserved.                                                  *
 *                                                                         *
 * Redistribution and use in source and binary forms, with or without      *
 * modification, are permitted provided that the following conditions are  *
 * met:                                                                    *
 *                                                                         *
 *  1. Redistributions of source code must retain the above copyright      *
 *     notice, this list of conditions and the following disclaimer.       *
 *  2. Redistributions in binary form must reproduce the above copyright   *
 *     notice, this list of conditions and the following disclaimer in the *
 *     documentation and/or other materials provided with the distribution.*
 *                                                                         *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     *
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       *
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A *
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      *
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   *
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        *
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   *
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   *
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     *
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   *
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    *
 ***************************************************************************/

#ifndef STELLARIS_K6X8_K6X8_H
#define STELLARIS_K6X8_K6X8_H

#include <stdint.h>

#define VIRTUAL_LINE_NUM 256
#define X_CHARCTER_NUM 16
#define X_PIXEL_NUM ( X_CHARCTER_NUM * 6 )

typedef struct {
  const char *line_head[ VIRTUAL_LINE_NUM ];
  const char *string_head;
  uint8_t buffer_head;
  uint8_t scroll;
  uint16_t current_line;
  uint16_t end_line;
  uint8_t mask;
  uint8_t buffer[ X_CHARCTER_NUM * 6 * 3 ];
  uint8_t scrolled_buffer[ X_CHARCTER_NUM * 6 * 2 ];
} FullScreenText;

extern const uint8_t mask[ 2 * 5 ];

void fstInit( FullScreenText *_fst, const char *_string );
void fstRenderLine( FullScreenText *_fst );
void fstScroll( FullScreenText *_fst, signed int _value );
int fstIsEnd( FullScreenText *_fst );
void fstMakeScrolledImage( FullScreenText *_fst );
void fstSetMask( FullScreenText *_fst, uint8_t _level );
void fstDisplay( FullScreenText *_fst );

#endif
